#include <bits/stdc++.h>
#define pb push_back
#define ll long long
using namespace std;
long long mod=1e9+7;
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    ll n;
    cin>>n;
    ll a[n+1],b[n+1];
    for(int i=1;i<=n;i++)cin>>a[i]>>b[i];
    ll r[n+1]={0};
    for(int i=1;i<=n;i++){
        ll vred=0;
        ll ind=0;
        ll p=0;
        vector<ll>v;
        for(int j=1;j<=i;j++){
            int p1=0,p2=0;
            for(int k=1;k<=i;k++){
                if(b[j]!=b[k])p2=1;
                if(a[j]!=a[k])p1=1;
            }
            if(p1==1&&p2==1){
                v.pb(j);
            }
        }
        if(!v.size())continue;
        //cout<<i<<"::: ";
        //for(auto it:v)cout<<it<<" ";
        //cout<<endl;
        for(auto it:v){
            ll o=0;
        for(int j=1;j<=it;j++){
                o+=(abs(a[j]-a[it]))*(abs(b[j]-b[it]));
            }
            vred=max(vred,o);
        }
        r[i]=vred;
    }
    for(int i=1;i<=n;i++)cout<<r[i]<<endl;
}